--- //depot/vendor/freebsd/src/sys/kern/init_main.c	2007/06/05 00:03:37
+++ //depot/user/attilio/attilio_schedlock/kern/init_main.c	2007/06/05 12:15:08
@@ -496,6 +496,7 @@
 proc0_post(void *dummy __unused)
 {
 	struct timespec ts;
+	struct thread *td;
 	struct proc *p;
 
 	/*
@@ -506,6 +507,14 @@
 	FOREACH_PROC_IN_SYSTEM(p) {
 		microuptime(&p->p_stats->p_start);
 		p->p_rux.rux_runtime = 0;
+		PROC_SLOCK(p);
+		FOREACH_THREAD_IN_PROC(p, td) {
+			td->td_runtime = 0;
+			td->sticks = 0;
+			td->iticks = 0;
+			td->uticks = 0;
+		}
+		PROC_SUNLOCK(p);
 	}
 	sx_sunlock(&allproc_lock);
 	PCPU_SET(switchtime, cpu_ticks());
